package web.multitask.trismegistoservices.api;

import kotlin.ParameterName;
import lombok.AllArgsConstructor;
import org.json.JSONObject;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import web.multitask.trismegistoservices.model.DriveRequest;
import web.multitask.trismegistoservices.services.DriveService;

import javax.annotation.Nullable;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("drive")
@AllArgsConstructor
public class DriveApi {

    DriveService driveService;

    @PostMapping(path = "/public/upload", consumes = {MediaType.MULTIPART_FORM_DATA_VALUE})
    public ResponseEntity<?> uploadFile(@ModelAttribute DriveRequest request) {
        String folder_id = request.getFolder_id();
        String file_name = request.getFile_name();
        MultipartFile file = request.getFile();
        String responseDrive = driveService.uploadFile(folder_id, file_name, file, new JSONObject());
        JSONObject response = new JSONObject();
        if (responseDrive == null) {
            response.put("status", false);
            response.put("message", "Error al subir el archivo");
            return ResponseEntity.badRequest().body(response.toMap());
        } else {
            response.put("status", true);
            response.put("message", "Archivo subido correctamente");
            response.put("file_id", responseDrive);
            return ResponseEntity.ok(response.toMap());
        }
    }

    @GetMapping(path = "/public/download/{id}")
    public ResponseEntity<?>  downloadFile(@PathVariable String id, @Nullable @RequestParam(name = "base64") Boolean base64) {
        if(base64 == null) base64 = false;
        return driveService.getFile(id, base64);
    }


}